/* 
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003, 2004    (see file CONTACTS for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include <Base/Geometry/PMatrixBase.hh>

using namespace BIAS;
using namespace std;

int main(int argc, char *argv[]){
  PMatrixBase P("497.9905512    1.440355214e-05    164.9405861     -1502.278858   79.17947938        415.6922058          226.56256       -2063.531797     0.3299144974    8.243640548e-08       0.9440108179        -8.59805053 ");

  PMatrixBase P2("286.845486      2.8e-05         164.940829       -1502.281035    -79.17938         415.692207         226.562599        -2063.53244 -0.329914                  0           0.944011          -8.598052");

  HomgPoint3D p3d(3.664444685, -9.783601761, 26.40313911);

  HomgPoint2D p2d;

  p2d=P * p3d;
  
  p2d.Homogenize();

  cerr <<"p2d: "<<p2d<<endl;

  
  p2d=P2 * p3d;
  
  p2d.Homogenize();

  cerr <<"p2d: "<<p2d<<endl;

  return 0;

}
