#include <iostream>
//#include <fstream>
//#include <iomanip>
//#include <string>
//#include <vector>

// BIAS:
//#include <Base/Debug/Debug.hh>

#include <Base/Image/Image.hh>
#include <Base/Image/ImageBase.hh>

#include <Base/Image/ImageIO.hh>

#ifndef BIAS_HAVE_IMAGEMAGICKLIB
#  error BIAS_HAVE_IMAGEMAGICKLIB not defined. Recompile BIAS with ImageMagick
#endif

#include <limits>

using namespace std;
using namespace BIAS;



void usage(int argc, char** argv){
  cerr<<"usage: "<<argv[0]<<" <image-filename>"<<endl;
}

//#ifdef WIN32
//  #undef min
//  #undef max
//#endif //WIN32

int main(int argc, char** argv)
{ 
  if (argc!=2) {
    usage(argc, argv);
    return 0;
  };
  
  //cout<< ::std::numeric_limits<double>::max() <<endl;
  cout<< ::std::numeric_limits<double>::epsilon() <<endl;
  exit (1);

  BIAS::Image<unsigned char> img;
  BIASASSERT(argc>1);
  string filename=argv[1];
  
  // BIAS::ImageIO::ImportImage(filename, img);
  BIAS::ImageIO::ImportMagickPPAutoconvert(filename, img);
  
  BIAS::ImageIO::ExportMagickPP("out_Magick.png", img);
  BIAS::ImageIO::ExportMagickPP("out_Magick_default.jpg", img);
  // BIAS::ImageIO::WriteMagickPP("out_Magick005.jpg", img, 5);
  // BIAS::ImageIO::WriteMagickPP("out_Magick100.jpg", img, 100);
  
  if (BIAS::ImageIO::ExportImage("out_Magick_ExportImage_FF_png.png", img, BIAS::ImageIO::FF_png ) !=BIAS_IO_SUCCESS){
    BIASERR("an error occurred using ExportImage");
  };
  
  if (BIAS::ImageIO::Write("out_Magick_Write.mip", img ) !=BIAS_IO_SUCCESS){
    BIASERR("an error occurred writing mip");
  };  
  
  cout<<"done"<<endl;
  return 0;
}
