#
# Dart client configuration
# server to submit results (used by client)
#

SET (DROP_SITE "dartserver"
  CACHE STRING "Address of remote drop site")

SET (DROP_SITE_USER "anonymous"
  CACHE STRING "Username for remote access to drop site.")

SET (DROP_SITE_PASSWORD "anonymous@ftp"
  CACHE STRING "Password for remote access to drop site.")

SET (DROP_LOCATION "/pub/in/BIAS" 
  CACHE STRING "Directory of drop site.")

SET (TRIGGER_SITE "http://${DROP_SITE}/cgi-bin/DartBIAS.pl"  
  CACHE STRING "URL for drop notification.")

SET (DROP_METHOD "ftp"
  CACHE STRING "Method for dropping files. Can be ftp, scp or cp.")



#
# Dart server configuration 
#
SET (CVS_WEB_URL "http://${DROP_SITE}/cgi-bin/viewcvs.cgi/BIAS/")
SET (CVS_WEB_CVSROOT "/home/cvs/bias")

SET (NIGHTLY_START_TIME "23:00:00 CEST"
  CACHE STRING "CVS snapshot timestamp for nightly builds")


OPTION(BUILD_DOXYGEN "Build source documentation using doxygen" "On")
SET (DOXYGEN_URL "http://${DROP_SITE}/doxyBIAS/")
SET (USE_DOXYGEN "On")
SET (DOXYGEN_CONFIG "${BIAS_BINARY_DIR}/doxy.config")



SET (USE_GNATS "Off")
#SET (GNATS_WEB_URL "http://${DROP_SITE}/")

SET( DETECT_REPEATED_ERRORS ON )

## Project Home Page for HOME button 
SET (PROJECT_URL "http://dartserver")

## Email notification system
SET (DELIVER_BROKEN_BUILD_EMAIL "Nightly")
SET (DELIVER_BROKEN_BUILD_EMAIL_WITH_TEST_FAILURES ON)
SET (EMAIL_FROM "dart@mip.informatik.uni-kiel.de")
SET (DARTBOARD_BASE_URL "${PROJECT_URL}/BIAS/Testing/HTML/TestingResults")
SET (EMAIL_PROJECT_NAME "BIAS")

## filter by build site and build name to specific monitor email adrs, e.g. Linux/Win32 distinction
SET (BUILD_MONITORS "{.* .* jw@mip.informatik.uni-kiel.de}")

## notify CVS users who checked in: 
#SET (CVS_IDENT_TO_EMAIL  "{dart DO_NOT_EMAIL} {cvs DO_NOT_EMAIL}  {nightlybuild DO_NOT_EMAIL} {.* {\0@mip.informatik.uni-kiel.de} }")
SET (CVS_IDENT_TO_EMAIL  "{.* jw@mip.informatik.uni-kiel.de}")

SET (SMTP_MAILHOST "leine")

SET (DELIVER_BROKEN_BUILD_EMAIL_WITH_CONFIGURE_FAILURES 1)
SET (DELIVER_BROKEN_BUILD_EMAIL_WITH_BUILD_ERRORS 1)
SET (DELIVER_BROKEN_BUILD_EMAIL_WITH_BUILD_WARNINGS 1)
SET (DELIVER_BROKEN_BUILD_EMAIL_WITH_TEST_NOT_RUNS 1)
SET (DELIVER_BROKEN_BUILD_EMAIL_WITH_TEST_FAILURES 1)

SET(DELIVER_CONTINUOUS_BUILD_EMAIL OFF)



## valgrind memory leak debugger 
SET(VALGRIND_COMMAND "/usr/bin/valgrind"
  CACHE STRING "CVS snapshot timestamp for nightly builds")

SET(VALGRIND_COMMAND_OPTIONS "-q --skin=memcheck --leak-check=yes --show-reachable=yes --workaround-gcc296-bugs=yes --num-callers=100"
  CACHE STRING "options for valgrind")


# logo for Dart HTML pages
CONFIGURE_FILE(
  ${BIAS_SOURCE_DIR}/img/BIASlogo.gif
  ${BIAS_BINARY_DIR}/Testing/HTML/TestingResults/Icons/Logo.gif
  COPYONLY
)


MARK_AS_ADVANCED(
  NIGHTLY_START_TIME
  DROP_METHOD
  DROP_SITE
  DROP_LOCATION
  DROP_SITE_USER
  DROP_SITE_PASSWORD
  TRIGGER_SITE
  VALGRIND_COMMAND
  VALGRIND_COMMAND_OPTIONS
)
