/* 
This file is part of the BIAS library (Basic ImageAlgorithmS).

Copyright (C) 2003, 2004    (see file CONTACTS for details)
  Multimediale Systeme der Informationsverarbeitung
  Institut fuer Informatik
  Christian-Albrechts-Universitaet Kiel


BIAS is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or
(at your option) any later version.

BIAS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BIAS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include <iostream>
#include <unistd.h>
#include <string>
#include <sstream>
#include <iomanip>
#include <vector>
#include <cstdlib>
#include <Base/Image/Image.hh>
#include <Base/Image/ImageIO.hh>
#include <Gui/GuiGTK.hh>

using namespace BIAS;
using namespace std;

int main(int argc, char *argv[])
{
  int num=5;
  ostringstream name;
  vector<Image<unsigned char> > image;
  vector<GuiGTK> gui;
  
  gui.resize(num);
  image.resize(num);
  for (int i=0; i<num; i++){
    image[i].Init(360, 288, 1);
    image[i].FillImageWithXValue();
    name.str("");
    name << " gui "<<i;
    gui[i].SetTitle(name.str());
    gui[i].ShowImage(image[i]);
  }

  char key=-1;
  while (key==-1){
    for (int i=0; i<num; i++){
      image[i].FillImageWithConstValue((unsigned char)random());
      gui[i].ShowImage(image[i]);
      if ((key=gui[i].CheckForKeyEvent())!=-1) break;
    }
  }
  return 0;
}











