#include "../CameraParam.hh"
#include "../RigParameter.hh"
#include <iostream>

using namespace std;
using namespace MIP;
using namespace BIAS;

// this is an preliminary example of how to write a rigparameter file
// given some pmatrices (2004-06-21).
// rigparameter does not yet fully work, if it does, this example has to be
// updated because K and other params have to be stored in a central place
// and some "virtual" pixel sizes have to be set.


int main (int argc, char* argv[])
{
#ifdef BIAS_HAVE_XML2
  cout <<"Usage: "<<endl<<"   "
       <<argv[0]<<" output.xml pfile1 [pfile2 ...]" <<endl;
  if (argc<2) return -1;
  
  RigParameter rp;
  
  // read all pmatrices from command line file names
  vector<PMatrix> vecPMatrices;
  for (int param=2; param<argc; param++) {
    PMatrix P;
    if (!P.Load(argv[param])) {
      BIASERR("Error reading pmatrix "<<argv[param]<<" STOPPING.");
      exit(-1);
    }
    cout <<"Loaded P("<< param-1<<") from file "<<argv[param]<<" :"<<P<<endl;
    vecPMatrices.push_back(P);
    
    KMatrix K(P.GetK());
    CameraParam myCameraParam;
    myCameraParam.SetZoomCamera(false);
    myCameraParam.SetFocalLength(K[0][0]);
    myCameraParam.SetPrincipal(K[0][2], K[1][2]);
    myCameraParam.SetCellSizeInMicr(1000, 1000*K[1][1]/K[0][0]);
    // myCameraParam.SetSkew(K[0][1]);

    rp.Camera.push_back(myCameraParam);
    rp.Calibration.push_back(K);
  }

  // set first to reference and compute rig params
  rp.Compute(vecPMatrices, vecPMatrices.size());
  rp.WriteRigData(argv[1]);
  cout <<"Wrote "<<argv[1] << endl;
#endif

  return 0;  
}
