/**
   \todo implement command line switch to terminate biasviewwx automatically 
   with useful return code for dart ADD_TEST to be able to test biasvviewwx 
   run in nightly cmake Dart dashboard (JW)
   \bug biasviewwx keycodes backspace, 's' dont work (with wx 2.5.x)
   \todo move the buttons to teh top to avoid jumping in case of different siezed images
   \todo add menus for functions  
   \bug resize of image display canvas is not correct in case of seq. of different sied images (JW, Linux) 
   \bug doesn't work n WIN32: probems: button event handler, key event handler, exit eventy handler... etc. 
 */


#include <wx/wx.h>
#include <wx/spinctrl.h>
#include <wx/timer.h>

#include <Gui/ImageCanvas.hh>
#include <Base/Image/ImageIO.hh>
#include <vector>

using namespace BIAS;
using namespace std;

#undef WXWIN_COMPATIBILITY

#define ID_TIMERUC 1001
#define ID_TIMERF 1002

enum {
ID_Quit = 1,
ID_About,
ID_Load,
ID_next,
ID_prev,
ID_run,
ID_stop,
ID_Delay
};

/** @class biasviewwx
    @ingroup g_tools
    @brief
    @author evers 08 2004 */
class MyApp: public wxApp
{
  virtual bool OnInit();
};


class MyIC_UC;
class MyIC_Float;







IMPLEMENT_APP(MyApp);

class MyFrame: public wxFrame
{
public:

  MyFrame(const wxString& title, const wxPoint& pos, const wxSize& size);

  void OnQuit(wxCommandEvent& event);
  void OnClose(wxCloseEvent& event);
  void OnAbout(wxCommandEvent& event);
  void OnLoad(wxCommandEvent& event);
  void OnNext(wxCommandEvent& event);
  void OnPrevious(wxCommandEvent& event);
  void OnRun(wxCommandEvent& event);
  void OnStop(wxCommandEvent& event);
  void OnDelay(wxSpinEvent &event);
  void OnKey(wxKeyEvent& event);
  //void OnPaint(wxPaintEvent& event);

  int LoadNewImage(const wxString &file);
  int LoadImageFromList(const unsigned int num);
  MyIC_UC *Ic_UC_;
  MyIC_Float *Ic_Float_;
  bool ActiveFloat_;
  wxStaticText *DelayLabel_;
  unsigned int Delay_;
  bool SlideShow_;
  vector<string> files_;
  unsigned int currentImg_;
  wxBoxSizer *MainSizer_;
  DECLARE_EVENT_TABLE();
};


class MyIC_UC: public ImageCanvas
{
public:
  MyIC_UC(wxWindow* parent, wxStatusBar* sbar=NULL,
          int sbarid=0, wxWindowID id = -1,
          const wxPoint& pos = wxDefaultPosition,
          const wxSize& size = wxSize(320, 240),
          long style = wxHSCROLL | wxVSCROLL,
          const wxString& name = "ScrolledWindow") 
    :ImageCanvas(parent,sbar,sbarid,id,pos,size,style,name)
    ,timer_()
  {
    timer_.SetOwner(this, ID_TIMERUC);
  };
  void OnLeftMouse(wxMouseEvent& event) {
    wxClientDC dc(this);
    PrepareDC(dc);
    wxPoint pos = event.GetPosition();
    unsigned x = (unsigned) dc.DeviceToLogicalX( pos.x );
    unsigned y = (unsigned) dc.DeviceToLogicalY( pos.y );  
    cout << "Left Mouse Button was pressed on pos X=" 
         << x << " Y=" << y << endl;
  }

  void  OnKey(wxKeyEvent& event) {
    //long evkey = event.KeyCode();
    long evkey = event.GetKeyCode();

    if (evkey <300) {
      //     cout <<"pressed: "<<evkey<<endl;
      switch (evkey) {
      case 'm' :
        origim_.PrintHeader(cout);
        cout <<endl<<"UUID: "<<origim_.GetUID()<<endl;
        cout <<"-------------------------------"<<endl;
        break;
      default: frame_->OnKey(event);
      }
    }
  }

  void OnTimer(wxTimerEvent& event){
    frame_->currentImg_ ++;
    if (frame_->currentImg_ >= frame_->files_.size())
      frame_->currentImg_ = 0;
    frame_->LoadImageFromList(frame_->currentImg_); 
  }

  MyFrame *frame_;
  wxTimer timer_;
  DECLARE_EVENT_TABLE();
};// Class MyIC_UC



class MyIC_Float: public ScaledImageCanvas
{
public:
  MyIC_Float(wxWindow* parent, wxStatusBar* sbar=NULL,
	  int sbarid=0, wxWindowID id = -1,
	  const wxPoint& pos = wxDefaultPosition,
	  const wxSize& size = wxSize(320, 240),
	  long style = wxHSCROLL | wxVSCROLL,
	  const wxString& name = "ScrolledWindow") 
    :ScaledImageCanvas(parent,sbar,sbarid,id,pos,size,style,name)
    ,timer_()
  {
    timer_.SetOwner(this, ID_TIMERF);
  };
  void  OnKey(wxKeyEvent& event){
    //long evkey = event.KeyCode();
    long evkey = event.GetKeyCode();

    if (evkey <300) {
      //     cout <<"pressed: "<<evkey<<endl;
      switch (evkey) {
      case 'm' :
	origim_.PrintHeader(cout);
	cout <<endl<<"UUID: "<<origim_.GetUID()<<endl;
	cout <<"-------------------------------"<<endl;
	break;
      default: frame_->OnKey(event);
      }
    }
  }

  void OnTimer(wxTimerEvent& event){
    frame_->currentImg_ ++;
    if (frame_->currentImg_ >= frame_->files_.size())
      frame_->currentImg_ = 0;
    frame_->LoadImageFromList(frame_->currentImg_); 
  }

  MyFrame *frame_;
  wxTimer timer_;
  DECLARE_EVENT_TABLE();
};// Class MyIC_Float




bool MyApp::OnInit()
{
  MyFrame *frame = new MyFrame( "ImageCanvas", wxPoint(50,50), 
                                wxSize(500,500) );
  for ( int i=1;i<argc; i++)
    frame->files_.push_back(argv[i]);
  if (argc>1) frame->LoadImageFromList(0);
    frame->currentImg_ = 0;
  frame->Show(TRUE);
  SetTopWindow(frame);
  frame->Ic_UC_->SetFocus();
  return TRUE;
} 

BEGIN_EVENT_TABLE(MyFrame, wxFrame)
  //EVT_PAINT(MyFrame::OnPaint)
  EVT_MENU(ID_Quit, MyFrame::OnQuit)
  EVT_MENU(ID_About, MyFrame::OnAbout)
  EVT_MENU(ID_Load, MyFrame::OnLoad)
  EVT_BUTTON(ID_Quit, MyFrame::OnQuit)
  EVT_BUTTON(ID_next, MyFrame::OnNext)
  EVT_BUTTON(ID_prev, MyFrame::OnPrevious)
  EVT_BUTTON(ID_run, MyFrame::OnRun)
  EVT_BUTTON(ID_stop, MyFrame::OnStop)
  EVT_SPINCTRL(ID_Delay, MyFrame::OnDelay)
  EVT_CLOSE(MyFrame::OnClose)
END_EVENT_TABLE()

BEGIN_EVENT_TABLE(MyIC_UC, ImageCanvas)
  EVT_CHAR(MyIC_UC::OnKey )
  EVT_LEFT_DOWN(MyIC_UC::OnLeftMouse)
  EVT_TIMER(ID_TIMERUC, MyIC_UC::OnTimer)
END_EVENT_TABLE()

BEGIN_EVENT_TABLE(MyIC_Float, ScaledImageCanvas)
  EVT_CHAR(MyIC_Float::OnKey )
  EVT_TIMER(ID_TIMERF, MyIC_Float::OnTimer)
END_EVENT_TABLE()


MyFrame::MyFrame(const wxString& title, const wxPoint& pos, const wxSize& size)
  : wxFrame((wxFrame *)NULL, -1, title, pos, size)
{
  wxMenu *menuFile = new wxMenu;
  Delay_ = 100;
  SlideShow_ = false;

  menuFile->Append( ID_About, "&About..." );
  menuFile->Append( ID_Load, "&Load..." );
  menuFile->AppendSeparator();
  menuFile->Append( ID_Quit, "E&xit" );

  wxMenuBar *menuBar = new wxMenuBar;
  menuBar->Append(menuFile, "&File");
  SetMenuBar(menuBar);

  CreateStatusBar(2);
  SetStatusText("ImageName", 0);
  ActiveFloat_ = false;
  MainSizer_=new wxBoxSizer(wxVERTICAL);
  Ic_UC_=new MyIC_UC(this, GetStatusBar(), 1);
  Ic_UC_->frame_ = this;
  MainSizer_->Add(Ic_UC_, 1, wxALL| wxGROW |wxALIGN_CENTER, 5);
  MainSizer_->SetSizeHints(this);
  Ic_Float_ = NULL;
  wxBoxSizer *box2=new wxBoxSizer(wxHORIZONTAL);
  wxButton *button = new wxButton(this,ID_next,"Next (SPC)");
  box2->Add(button);
  button = new wxButton(this,ID_prev,"Prev (BkSPC)");
  box2->Add(button);  
  button = new wxButton(this,ID_run,"Run (s)");
  box2->Add(button);  
  button = new wxButton(this,ID_stop,"Stop (s)");
  box2->Add(button);  
  wxString s;
  s.Printf("Delay: (+/-): %4d",Delay_);
  DelayLabel_ =new wxStaticText(this,-1,s);
  box2->Add(DelayLabel_);

//   wxSpinButton *spin = new wxSpinButton(this,ID_Delay);
//   spin->SetRange(10,1000);
//   spin->SetValue(Ic_UC_->Delay_);
//   box2->Add(spin);

  button = new wxButton(this,ID_Quit,"Quit");
  box2->Add(button);  

  MainSizer_->Add(box2);

  SetSizer(MainSizer_);
  FitInside();
}

void MyFrame::OnQuit(wxCommandEvent& event)
{ 
  Ic_UC_->Destroy();
  this->Destroy();
}

void MyFrame::OnClose(wxCloseEvent& event)
{ 
  Ic_UC_->Destroy();
  this->Destroy();
}

//void MyFrame::OnPaint(wxPaintEvent & event)
//{ 
//  wxWindowDC dc(this);
//}

void MyFrame::OnAbout(wxCommandEvent& WXUNUSED(event))
{
  wxMessageBox("This is a wxWindows Hello world sample",
             "About Hello World", wxOK | wxICON_INFORMATION, this);
}

void MyFrame::OnLoad(wxCommandEvent& WXUNUSED(event))
{
  wxFileDialog fileDialog(this, "Choose a file", ".", "ucim.pgm");
  if (fileDialog.ShowModal() == wxID_OK){
    files_.push_back((string)fileDialog.GetPath());
    LoadImageFromList(files_.size()-1);
  } else {
    cerr << "canceled loadin image" << endl;
  }
}

int MyFrame::LoadNewImage(const wxString &file)
{
  ImageBase imbase;
  bool minmaxset = false; 
  float maxs=0,mins=0,maxo=0,mino=0; // brightness offset/scale ranges
  if (ImageIO::Load(file.c_str(), imbase)!=0){
    BIASERR("errro loading "<<file);
    return -1;
  } else {
    unsigned int w = imbase.GetWidth();
    unsigned int h = imbase.GetHeight();
    // clip to usefull min/max
    if (w<500) w = 500; if (w>1100) w = 1100;
    if (h<450) h = 450; if (h>900) h = 900;
    // add some space for the borders
    //     SetSize(w+25,h+60);
    SetStatusText(file, 0);
    switch (imbase.GetStorageType())  {
    case   ImageBase::ST_unsignedchar:
      {
        if (ActiveFloat_) {
          Ic_Float_->Show(false);
          MainSizer_->Remove(0);
          MainSizer_->Prepend(Ic_UC_, 1, wxALL| wxGROW |wxALIGN_CENTER, 5);
        }
        Image<unsigned char> im;
        im.StealImage(imbase);  
        Ic_UC_->Show(im, file.c_str());
        if (ActiveFloat_) 
          Ic_UC_->Show(true);
        ActiveFloat_ = false;
      }
      break;
    case ImageBase::ST_unsignedshortint: 
      if (!minmaxset) {
        mins = 1.0/16.0;
        maxs = 1.0;
        mino = -4095.0;
        maxo  = 0.0;
        minmaxset = true;
      }
    case ImageBase::ST_char:
      if (!minmaxset) {
          minmaxset = true;
          mins = 0.5;
          maxs = 5.0;
          mino = -128.0;
          maxo =  128.0;
        }
    case ImageBase::ST_float: 
      {  
        if (!minmaxset) {
          minmaxset = true;
          mins = 0.5;
          maxs = 50.0;
          mino = -100.0;
          maxo =  100.0;
        }
        if (Ic_Float_ ==NULL) {
          Ic_Float_=new MyIC_Float(this, GetStatusBar(), 1);
          Ic_Float_->frame_ = this;
        }
        if (!ActiveFloat_) {
          Ic_UC_->Show(false);
          MainSizer_->Remove(0);
          MainSizer_->Prepend(Ic_Float_, 1, wxALL| wxGROW |wxALIGN_CENTER, 5);
        }
        Ic_Float_->Show(imbase, file.c_str());
        if (!ActiveFloat_) Ic_Float_->Show(true);
        ActiveFloat_ = true;
        Ic_Float_->SetScaleRange(mins, maxs);
        Ic_Float_->SetOffsetRange(mino, maxo);
      }
      break;

    default: ;
    }  
    SetSize(w+25,h+90);
	Refresh();
  }
  return 0;
}

int MyFrame::LoadImageFromList(const unsigned int num)
{

  return LoadNewImage(files_[num].c_str());
}


void MyFrame::OnNext(wxCommandEvent& event)
{
  currentImg_ ++;
  if (currentImg_ >= files_.size())   currentImg_ = 0;
  if (files_.size()>0) LoadImageFromList(currentImg_); 
}


void MyFrame::OnPrevious(wxCommandEvent& event)
{
  if (currentImg_ >0) currentImg_ --;
  else currentImg_ = files_.size() -1;
  if (files_.size()>0) LoadImageFromList(currentImg_); 
}


void MyFrame::OnRun(wxCommandEvent& event)
{
  Ic_UC_->timer_.Start(Delay_);
  SlideShow_ = true;
}

void MyFrame::OnStop(wxCommandEvent& event)
{
  Ic_UC_->timer_.Stop();
  SlideShow_ = false;
}

void MyFrame::OnDelay(wxSpinEvent &event)
{
  int pos = event.GetPosition();
  int diff = pos - Delay_ ;
  Delay_  += diff *10;
  wxSpinCtrl *spin =  (wxSpinCtrl *) event.GetEventObject();
  spin -> SetValue(Delay_);
  if(SlideShow_)  Ic_UC_->timer_.Start(Delay_);
  cout <<"Delay: "<<Delay_<<endl;
   wxString s;
 s.Printf("Delay: (+/-): %4d",Delay_);
  DelayLabel_->SetLabel(s);

}


void  MyFrame::OnKey(wxKeyEvent& event)
{
  //long evkey = event.KeyCode();
  long evkey = event.GetKeyCode();

  wxCommandEvent fakeEvent;
  wxString s;
  switch (evkey) {
    case 27: 
    case 'q':
    case 'Q':
      Close(true); break;
    case ' ': 
      OnNext(fakeEvent);
      break;
    case 8: 
      OnPrevious(fakeEvent);
      break;  
    case 's': 
      if (SlideShow_) OnStop(fakeEvent);
      else OnRun(fakeEvent);
      break;
    case '+' :
      if (Delay_>10) Delay_-=10;
      if (SlideShow_) Ic_UC_->timer_.Start(Delay_);
      s.Printf("Delay: (+/-): %4d",Delay_);
      DelayLabel_->SetLabel(s);
      break;
    case '-' : 
      if (Delay_<1000) Delay_+=10;
      if (SlideShow_) Ic_UC_->timer_.Start(Delay_); 
      s.Printf("Delay: (+/-): %4d",Delay_);
      DelayLabel_->SetLabel(s);
      break;
  }
}
