

#include <wx/wx.h>
#include <wx/timer.h>

#include <Gui/ImageCanvas.hh>
#include <vector>

using namespace BIAS;
using namespace std;

#undef WXWIN_COMPATIBILITY


enum {
ID_Quit = 1,

};

/** @class biasviewwx
    @ingroup g_tools
    @brief
    @author evers 08 2004 */
class MyApp: public wxApp
{
  virtual bool OnInit();
};








IMPLEMENT_APP(MyApp);

class MyFrame: public wxFrame
{
public:

  MyFrame(const wxString& title, const wxPoint& pos, const wxSize& size);

  void OnQuit(wxCommandEvent& event);

  MyIC_UC *Ic_;
  wxBoxSizer *MainSizer_;
  DECLARE_EVENT_TABLE();
};


class MyIC_UC: public ImageCanvas
{
public:
  MyIC_UC(wxWindow* parent, wxStatusBar* sbar=NULL,
          int sbarid=0, wxWindowID id = -1,
          const wxPoint& pos = wxDefaultPosition,
          const wxSize& size = wxSize(320, 240),
          long style = wxHSCROLL | wxVSCROLL,
          const wxString& name = "ScrolledWindow") 
    :ImageCanvas(parent,sbar,sbarid,id,pos,size,style,name)
#ifdef WIN32
    ,timer_(NULL, ID_Timer)
#else
    ,timer_(this, ID_Timer)
#endif

  {
#ifdef WIN32
    timer_.SetOwner(this);
#endif
  };
  void OnLeftMouse(wxMouseEvent& event) {
    wxClientDC dc(this);
    PrepareDC(dc);
    wxPoint pos = event.GetPosition();
    unsigned x = (unsigned) dc.DeviceToLogicalX( pos.x );
    unsigned y = (unsigned) dc.DeviceToLogicalY( pos.y );  
    cout << "Left Mouse Button was pressed on pos X=" 
         << x << " Y=" << y << endl;
  }

  void  OnKey(wxKeyEvent& event) {
    //long evkey = event.KeyCode();
    long evkey = event.GetKeyCode();

    if (evkey <300) {
      //     cout <<"pressed: "<<evkey<<endl;
      switch (evkey) {
      case 'm' :
        origim_.PrintHeader(cout);
        cout <<endl<<"UUID: "<<origim_.GetUID()<<endl;
        cout <<"-------------------------------"<<endl;
        break;
      default: frame_->OnKey(event);
      }
    }
  }



  void OnTimer(wxTimerEvent& event){
    frame_->currentImg_ ++;
    if (frame_->currentImg_ >= frame_->files_.size())
      frame_->currentImg_ = 0;
    frame_->LoadImageFromList(frame_->currentImg_); 
  }
  MyFrame *frame_;
  wxTimer timer_;
  DECLARE_EVENT_TABLE();
};// Class MyIC_UC






bool MyApp::OnInit()
{
  MyFrame *frame = new MyFrame( "ImageCanvas", wxPoint(50,50), 
                                wxSize(500,500) );
  for ( int i=1;i<argc; i++)
    frame->files_.push_back(argv[i]);
  if (argc>1) frame->LoadImageFromList(0);
    frame->currentImg_ = 0;
  frame->Show(TRUE);
  SetTopWindow(frame);
  frame->Ic_UC_->SetFocus();
  return TRUE;
} 

BEGIN_EVENT_TABLE(MyFrame, wxFrame)
  EVT_MENU(ID_Quit, MyFrame::OnQuit)
  EVT_MENU(ID_About, MyFrame::OnAbout)
  EVT_MENU(ID_Load, MyFrame::OnLoad)
  EVT_BUTTON(ID_Quit, MyFrame::OnQuit)
  EVT_BUTTON(ID_next, MyFrame::OnNext)
  EVT_BUTTON(ID_prev, MyFrame::OnPrevious)
  EVT_BUTTON(ID_run, MyFrame::OnRun)
  EVT_BUTTON(ID_stop, MyFrame::OnStop)
  EVT_SPINCTRL(ID_Delay, MyFrame::OnDelay)

END_EVENT_TABLE()

BEGIN_EVENT_TABLE(MyIC_UC, ImageCanvas)
  EVT_CHAR(MyIC_UC::OnKey )
  EVT_LEFT_DOWN(MyIC_UC::OnLeftMouse)
  EVT_TIMER(ID_Timer, MyIC_UC::OnTimer)
END_EVENT_TABLE()

BEGIN_EVENT_TABLE(MyIC_Float, ScaledImageCanvas)
   EVT_CHAR(MyIC_Float::OnKey )
  EVT_TIMER(ID_Timer, MyIC_Float::OnTimer)
END_EVENT_TABLE()


MyFrame::MyFrame(const wxString& title, const wxPoint& pos, const wxSize& size)
  : wxFrame((wxFrame *)NULL, -1, title, pos, size)
{
  wxMenu *menuFile = new wxMenu;
  Delay_ = 100;
  SlideShow_ = false;


  CreateStatusBar(2);
  SetStatusText("ImageName", 0);
  MainSizer_=new wxBoxSizer(wxVERTICAL);
  Ic_ =new MyIC_UC(this, GetStatusBar(), 1);
  Ic_UC_->frame_ = this;
  MainSizer_->Add(Ic_UC_, 1, wxALL| wxGROW |wxALIGN_CENTER, 5);
  MainSizer_->SetSizeHints(this);
  wxBoxSizer *box2=new wxBoxSizer(wxHORIZONTAL);
  wxButton *button ;
  button = new wxButton(this,ID_Quit,"Quit");
  box2->Add(button);  

  MainSizer_->Add(box2);

  SetSizer(MainSizer_);
  FitInside();
}

void MyFrame::OnQuit(wxCommandEvent& WXUNUSED(event))
{ 
  Destroy();
}

