#include <iostream>

#include <Utils/GenSynthMatches.hh>
#include <Base/Image/ImageIO.hh>


using namespace BIAS;
using namespace std;

#define DEFAULT_PARA_FILE_NAME "GenSynthMatches.ini"
#define DEBUG true

int main(int argc, char *argv[]) 
{
  Param para;
  GenSynthMatches gsm(para), gsm2(para);
  //  gsm.AddDebugLevel(GSM_CAM_MOTION);
  //  gsm.AddDebugLevel(GSM_VIEWINGVOL);
  //  gsm.AddDebugLevel(GSM_3D_POINTS);
  //  gsm.AddDebugLevel(GSM_2D_MATCHES);
    gsm.AddDebugLevel(GSM_MOVIN_TRANSF);
  //gsm.AddDebugLevel(GSM_MOVIN_3D_POINTS);


  bool FoundDefaultParaFile=true;
  ifstream is(DEFAULT_PARA_FILE_NAME);
  if (!is){ 
    is.close(); 
    if (DEBUG) cerr << "reading "<<DEFAULT_PARA_FILE_NAME<<" failed"<<endl;
    FoundDefaultParaFile=false;
  } else {
    if (DEBUG) cerr << "reading "<<DEFAULT_PARA_FILE_NAME<<endl;
    para.ReadParameter(DEFAULT_PARA_FILE_NAME);
  }

  int argind = para.ParseCommandLine(argc, argv);
  if (argind<0){
    BIASERR("error parsing command line");
    return -1;
  }

  if ((!FoundDefaultParaFile) && (*para.GetParamString("readconfig")=="")) {
    cerr << "no parameter file found, writing default to "
         <<DEFAULT_PARA_FILE_NAME<<"\n"; 
    para.WriteParameter(DEFAULT_PARA_FILE_NAME, false); 
  }


  gsm.CreateMatches();

  cout << gsm <<endl;
  gsm.Write("data.txt");

  gsm2.Read("data.txt");
  
  cout << gsm2 <<endl;

//   cout << gsm._MovingTransform[2] << endl;
//   cout << gsm2._MovingTransform[2] << endl;

  Image<unsigned char> im;
  gsm.DrawTrue(im, 0, 2);

  ImageIO::Write("true.mip", im);

  gsm.DrawNoisy(im, 0, 2);

  ImageIO::Write("noisy.mip", im);

  gsm2.DrawTrue(im, 0, 2);

  ImageIO::Write("true2.mip", im);

  gsm2.DrawNoisy(im, 0, 2);

  ImageIO::Write("noisy2.mip", im);

  
  return 0;

}
